* defs.h (extract_long_unsigned_integer): Declare.
[deliverable/binutils-gdb.git] / configure.in
... / ...
CommitLineData
1##############################################################################
2
3## This file is a shell script fragment that supplies the information
4## necessary to tailor a template configure script into the configure
5## script appropriate for this directory. For more information, check
6## any existing configure script.
7
8## Be warned, there are two types of configure.in files. There are those
9## used by Autoconf, which are macros which are expanded into a configure
10## script by autoconf. The other sort, of which this is one, is executed
11## by Cygnus configure.
12
13## For more information on these two systems, check out the documentation
14## for 'Autoconf' (autoconf.texi) and 'Configure' (configure.texi).
15
16##############################################################################
17
18### To add a new directory to the tree, first choose whether it is a target
19### or a host dependent tool. Then put it into the appropriate list
20### (library or tools, host or target), doing a dependency sort. For
21### example, gdb requires that byacc (or bison) be built first, so it is in
22### the ${host_tools} list after byacc and bison.
23
24
25# these libraries are used by various programs built for the host environment
26#
27host_libs="mmalloc libiberty opcodes bfd readline gash tcl tk tclX"
28
29if [ "${enable_gdbgui}" = "yes" ] ; then
30 host_libs="${host_libs} libgui"
31fi
32
33# these tools are built for the host environment
34#
35host_tools="texinfo byacc flex bison binutils ld gas gcc gdb make patch
36 prms send-pr gprof gdbtest tgas etc expect dejagnu sim
37 m4 autoconf ispell grep diff rcs cvs fileutils shellutils
38 textutils wdiff find emacs emacs19 uudecode hello tar gzip indent
39 recode release sed utils"
40
41
42# these libraries are built for the target environment, and are built after
43# the host libraries and the host tools (which may be a cross compiler)
44#
45target_libs="target-libiberty target-libgloss target-newlib target-libio target-librx target-libstdc++ target-libg++"
46
47
48# these tools are built using the target libs, and are intended to run only
49# in the target environment
50#
51# note: any program that *uses* libraries that are in the "target_libs"
52# list belongs in this list. those programs are also very likely
53# candidates for the "native_only" list which follows
54#
55target_tools="target-examples target-groff"
56
57################################################################################
58
59## These two lists are of directories that are to be removed from the
60## ${configdirs} list for either cross-compilations or for native-
61## compilations. For example, it doesn't make that much sense to
62## cross-compile Emacs, nor is it terribly useful to compile target-libiberty in
63## a native environment.
64
65# directories to be built in the native environment only
66#
67native_only="autoconf cvs emacs emacs19 fileutils find grep gzip hello
68 indent ispell m4 rcs recode sed shellutils tar textutils gash
69 uudecode wdiff gprof target-groff"
70
71# directories to be built in a cross environment only
72#
73cross_only="target-libiberty target-libgloss target-newlib"
74
75## All tools belong in one of the four categories, and are assigned above
76## We assign ${configdirs} this way to remove all embedded newlines. This
77## is important because configure will choke if they ever get through.
78## ${configdirs} is directories we build using the host tools.
79## ${target_configdirs} is directories we build using the target tools.
80#
81configdirs=`echo ${host_libs} ${host_tools}`
82target_configdirs=`echo ${target_libs} ${target_tools}`
83
84################################################################################
85
86srctrigger=move-if-change
87srcname="gnu development package"
88
89# This gets set non-empty for some net releases of packages.
90appdirs=""
91
92# per-host:
93
94# Work in distributions that contain no compiler tools, like Autoconf.
95if [ -d ${srcdir}/config ]; then
96case "${host}" in
97 m68k-hp-hpux*) host_makefile_frag=config/mh-hp300 ;;
98 m68k-apollo-sysv*) host_makefile_frag=config/mh-apollo68 ;;
99 m68k-apollo-bsd*) host_makefile_frag=config/mh-a68bsd ;;
100 m68k-*-linux*) host_makefile_frag=config/mh-linux ;;
101 m88k-dg-dgux*) host_makefile_frag=config/mh-dgux ;;
102 m88k-harris-cxux*) host_makefile_frag=config/mh-cxux ;;
103 m88k-motorola-sysv*) host_makefile_frag=config/mh-delta88;;
104 mips*-dec-ultrix*) host_makefile_frag=config/mh-decstation ;;
105 mips*-sgi-irix[56]*) host_makefile_frag=config/mh-irix5 ;;
106 mips*-sgi-irix4*) host_makefile_frag=config/mh-irix4 ;;
107 mips*-sgi-irix3*) host_makefile_frag=config/mh-sysv ;;
108 mips*-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
109 mips*-*-sysv*) host_makefile_frag=config/mh-riscos ;;
110 i[345]86-ncr-sysv4.3) host_makefile_frag=config/mh-ncrsvr43 ;;
111 i[345]86-ncr-sysv4*) host_makefile_frag=config/mh-ncr3000 ;;
112 i[345]86-*-sco3.2v5*) host_makefile_frag=config/mh-sysv ;;
113 i[345]86-*-sco*) host_makefile_frag=config/mh-sco ;;
114 i[345]86-*-isc*) host_makefile_frag=config/mh-sysv ;;
115 i[345]86-*-linux*) host_makefile_frag=config/mh-linux ;;
116 i[345]86-*-solaris2*) host_makefile_frag=config/mh-sysv4 ;;
117 i[345]86-*-aix*) host_makefile_frag=config/mh-aix386 ;;
118 i[345]86-*-go32*) host_makefile_frag=config/mh-go32 ;;
119 vax-*-ultrix2*) host_makefile_frag=config/mh-vaxult2 ;;
120 *-*-solaris2*) host_makefile_frag=config/mh-solaris ;;
121 m68k-sun-sunos*) host_makefile_frag=config/mh-sun3 ;;
122 *-hp-hpux[78]*) host_makefile_frag=config/mh-hpux8 ;;
123 *-hp-hpux*) host_makefile_frag=config/mh-hpux ;;
124 *-*-hiux*) host_makefile_frag=config/mh-hpux ;;
125 rs6000-*-lynxos*) host_makefile_frag=config/mh-lynxrs6k ;;
126 *-*-lynxos*) host_makefile_frag=config/mh-lynxos ;;
127 *-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
128 *-*-sysv*) host_makefile_frag=config/mh-sysv ;;
129esac
130fi
131
132# If we aren't going to be using gcc, see if we can extract a definition
133# of CC from the fragment.
134if [ -z "${CC}" -a "${build}" = "${host}" ]; then
135 IFS="${IFS= }"; save_ifs="$IFS"; IFS="${IFS}:"
136 found=
137 for dir in $PATH; do
138 test -z "$dir" && dir=.
139 if test -f $dir/gcc; then
140 found=yes
141 break
142 fi
143 done
144 IFS="$save_ifs"
145 if [ -z "${found}" -a -n "${host_makefile_frag}" -a -f "${srcdir}/${host_makefile_frag}" ]; then
146 xx=`sed -n -e 's/^[ ]*CC[ ]*=[ ]*\(.*\)$/\1/p' < ${srcdir}/${host_makefile_frag}`
147 if [ -n "${xx}" ] ; then
148 CC=$xx
149 fi
150 fi
151fi
152
153# We default to --with-shared on platforms where -fpic is meaningless.
154# Well, we don't yet, but we will.
155if false && [ "${host}" = "${target}" ] && [ x${enable_shared} = x ]; then
156 case "${target}" in
157 alpha-dec-osf*) enable_shared=yes ;;
158 mips-sgi-irix5*) enable_shared=yes ;;
159 *) enable_shared=no ;;
160 esac
161fi
162
163if [ x${enable_shared} = xyes ]; then
164 waugh=
165 case "${host}" in
166 hppa*) waugh=config/mh-papic ;;
167 i[345]86-*) waugh=config/mh-x86pic ;;
168 sparc64-*) waugh=config/mh-sparcpic ;;
169 *) waugh=config/mh-${host_cpu}pic ;;
170 esac
171 if [ -f ${srcdir}/${waugh} ]; then
172 if [ -n "${host_makefile_frag}" ] ; then
173 cat ${srcdir}/${host_makefile_frag} > mh-frag
174 cat ${srcdir}/${waugh} >> mh-frag
175 host_makefile_frag=mh-frag
176 else
177 host_makefile_frag=${waugh}
178 fi
179 fi
180fi
181
182# per-target:
183
184case "${target}" in
185 v810*) target_makefile_frag=config/mt-v810 ;;
186 i[345]86-*-netware*) target_makefile_frag=config/mt-netware ;;
187 powerpc-*-netware*) target_makefile_frag=config/mt-netware ;;
188esac
189
190skipdirs=
191gasdir=gas
192use_gnu_ld=
193use_gnu_as=
194
195# some tools are so dependent upon X11 that if we're not building with X,
196# it's not even worth trying to configure, much less build, that tool.
197
198case ${with_x} in
199 yes | "") # the default value for this tree is that X11 is available
200 ;;
201 no)
202 skipdirs="${skipdirs} tk gash"
203 ;;
204 *)
205 echo "*** bad value \"${with_x}\" for -with-x flag; ignored" 1>&2
206 ;;
207esac
208
209# Some tools are only suitable for building in a "native" situation.
210# Those are added when we have a host==target configuration. For cross
211# toolchains, we add some directories that should only be useful in a
212# cross-compiler.
213
214is_cross_compiler=
215
216if [ x"${host}" = x"${target}" ] ; then
217 # when doing a native toolchain, don't build the targets
218 # that are in the 'cross only' list
219 skipdirs="${skipdirs} ${cross_only}"
220 is_cross_compiler=no
221 target_subdir=.
222else
223 # similarly, don't build the targets in the 'native only'
224 # list when building a cross compiler
225 skipdirs="${skipdirs} ${native_only}"
226 is_cross_compiler=yes
227 target_subdir=${target_alias}
228 if [ ! -d ${target_subdir} ] ; then
229 if mkdir ${target_subdir} ; then true
230 else
231 echo "'*** could not make ${PWD=`pwd`}/${target_subdir}" 1>&2
232 exit 1
233 fi
234 fi
235fi
236
237copy_dirs=
238
239# Handle --with-headers=XXX. The contents of the named directory are
240# copied to $(tooldir)/sys-include.
241if [ x"${with_headers}" != x ]; then
242 if [ x${is_cross_compiler} = xno ]; then
243 echo 1>&2 '***' --with-headers is only supported when cross compiling
244 exit 1
245 fi
246 case "${exec_prefixoption}" in
247 "") x=${prefix} ;;
248 *) x=${exec_prefix} ;;
249 esac
250 copy_dirs="${copy_dirs} ${with_headers} $x/${target_alias}/sys-include"
251fi
252
253# Handle --with-libs=XXX. Multiple directories are permitted. The
254# contents are copied to $(tooldir)/lib.
255if [ x"${with_libs}" != x ]; then
256 if [ x${is_cross_compiler} = xno ]; then
257 echo 1>&2 '***' --with-libs is only supported when cross compiling
258 exit 1
259 fi
260 # Copy the libraries in reverse order, so that files in the first named
261 # library override files in subsequent libraries.
262 case "${exec_prefixoption}" in
263 "") x=${prefix} ;;
264 *) x=${exec_prefix} ;;
265 esac
266 for l in ${with_libs}; do
267 copy_dirs="$l $x/${target_alias}/lib ${copy_dirs}"
268 done
269fi
270
271# If both --with-headers and --with-libs are specified, default to
272# --without-newlib.
273if [ x"${with_headers}" != x ] && [ x"${with_libs}" != x ]; then
274 if [ x"${with_newlib}" = x ]; then
275 with_newlib=no
276 fi
277fi
278
279# Recognize --with-newlib/--without-newlib.
280if [ x${with_newlib} = xno ]; then
281 skipdirs="${skipdirs} target-newlib"
282elif [ x${with_newlib} = xyes ]; then
283 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
284fi
285
286# Default to using --with-stabs for certain targets.
287if [ x${with_stabs} = x ]; then
288 case "${target}" in
289 mips*-*-* | alpha*-*-osf* | i[345]86*-*-sysv4* | i[345]86*-*-unixware*)
290 with_stabs=yes;
291 withoptions="${withoptions} --with-stabs"
292 ;;
293 esac
294fi
295
296# Handle ${copy_dirs}
297set fnord ${copy_dirs}
298shift
299while [ $# != 0 ]; do
300 if [ -f $2/COPIED ] && [ x"`cat $2/COPIED`" = x"$1" ]; then
301 :
302 else
303 echo Copying $1 to $2
304
305 # Use the install script to create the directory and all required
306 # parent directories.
307 if [ -d $2 ]; then
308 :
309 else
310 echo >config.temp
311 ${srcdir}/install.sh -c -m 644 config.temp $2/COPIED
312 fi
313
314 # Copy the directory, assuming we have tar.
315 # FIXME: Should we use B in the second tar? Not all systems support it.
316 (cd $1; tar -cf - .) | (cd $2; tar -xpf -)
317
318 # It is the responsibility of the user to correctly adjust all
319 # symlinks. If somebody can figure out how to handle them correctly
320 # here, feel free to add the code.
321
322 echo $1 > $2/COPIED
323 fi
324 shift; shift
325done
326
327# Configure extra directories which are host specific
328
329case "${host}" in
330 i[345]86-*-go32*)
331 configdirs="$configdirs dosrel" ;;
332esac
333
334# Remove more programs from consideration, based on the host or
335# target this usually means that a port of the program doesn't
336# exist yet.
337
338noconfigdirs=""
339
340case "${host}" in
341 i[345]86-*-vsta)
342 noconfigdirs="tcl expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff"
343 ;;
344 i[345]86-*-go32)
345 noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff"
346 ;;
347 *-*-cygwin32)
348 noconfigdirs="patch diff make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs"
349 ;;
350 ppc*-*-pe)
351 noconfigdirs="patch diff make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs"
352 ;;
353esac
354
355
356case "${target}" in
357 *-*-netware)
358 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-librx target-newlib target-libiberty"
359 ;;
360 *-*-vxworks*)
361 noconfigdirs="$noconfigdirs target-newlib"
362 ;;
363 alpha-dec-osf*)
364 # ld works, but does not support shared libraries. emacs doesn't
365 # work. newlib is not 64 bit ready. I'm not sure about fileutils or grep.
366 # gas doesn't generate exception information.
367 noconfigdirs="$noconfigdirs gas ld emacs fileutils grep target-newlib"
368 ;;
369 alpha*-*-*)
370 # newlib is not 64 bit ready
371 noconfigdirs="$noconfigdirs target-newlib"
372 ;;
373# start-sanitize-arc
374 arc-*-*)
375 ;;
376# end-sanitize-arc
377 arm-*-pe*)
378 ;;
379 arm-*-riscix*)
380 noconfigdirs="$noconfigdirs ld"
381 ;;
382 h8300*-*-* | \
383 h8500-*-*)
384 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx"
385 ;;
386 hppa*-*-*elf* | \
387 hppa*-*-lites*)
388 # Do configure ld/binutils/gas for this case.
389 ;;
390 hppa*-*-*)
391 # HP's C compiler doesn't handle Emacs correctly (but on BSD and Mach
392 # cc is gcc, and on any system a user should be able to link cc to
393 # whatever they want. FIXME, emacs emacs19).
394 case "${CC}" in
395 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
396 *) ;;
397 esac
398 noconfigdirs="$noconfigdirs ld shellutils"
399 ;;
400 i[345]86-*-go32)
401 # but don't build gdb
402 noconfigdirs="$noconfigdirs gdb target-libg++ target-libstdc++ target-libio target-librx"
403 ;;
404 *-*-cygwin32)
405
406 # make/glob's configure uses some AC_TRY_RUN type tests
407 target_configdirs="$target_configdirs target-winsup"
408 noconfigdirs="$noconfigdirs tcl tk expect make"
409 # always build newlib.
410 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
411
412 # Can't build gdb for cygwin32 if not native.
413 case "${host}:${build}" in
414 *-*-cygwin32 | *-*-cygwin32:*-*-cygwin32) ;; # keep gdb
415 *) noconfigdirs="$noconfigdirs gdb"
416 esac
417
418 ;;
419 i[345]86-*-pe)
420 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx"
421 ;;
422 i[345]86-*-sco3.2v5*)
423 # The linker does not yet know about weak symbols in COFF,
424 # and is not configured to handle mixed ELF and COFF.
425 noconfigdirs="$noconfigdirs gprof ld"
426 ;;
427 i[345]86-*-sco*)
428 noconfigdirs="$noconfigdirs gprof"
429 ;;
430 i[345]86-*-solaris2*)
431 # The linker does static linking correctly, but the Solaris C library
432 # has bugs such that some important functions won't work when statically
433 # linked. (See man pages for getpwuid, for example.)
434 noconfigdirs="$noconfigdirs ld"
435 ;;
436 i[345]86-*-sysv4*)
437 # The SYSV4 C compiler doesn't handle Emacs correctly
438 case "${CC}" in
439 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
440 *) ;;
441 esac
442 # but that's okay since emacs doesn't work anyway
443 noconfigdirs="$noconfigdirs emacs emacs19"
444 ;;
445 powerpc-*-aix*)
446 # copied from rs6000-*-* entry
447 noconfigdirs="$noconfigdirs gprof cvs"
448 ;;
449 powerpc*-*-winnt* | powerpc*-*-pe* | ppc*-*-pe)
450 target_configdirs="$target_configdirs target-winsup"
451 noconfigdirs="$noconfigdirs gdb tcl tk make expect"
452 # always build newlib.
453 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
454 ;;
455 rs6000-*-lynxos*)
456 # The CVS server code doesn't work on the RS/6000
457 # Newlib makes problems for libg++ in crosses.
458 noconfigdirs="$noconfigdirs target-newlib gprof cvs"
459 ;;
460 rs6000-*-*)
461 noconfigdirs="$noconfigdirs gprof"
462 ;;
463 m68k-apollo-*)
464 noconfigdirs="$noconfigdirs ld binutils gprof"
465 ;;
466 mips*-*-irix5*)
467 # The GNU linker does not support shared libraries.
468 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
469 noconfigdirs="$noconfigdirs ld gprof emacs"
470 ;;
471 mips*-dec-bsd*)
472 noconfigdirs="$noconfigdirs gprof"
473 ;;
474 mips*-*-bsd*)
475 noconfigdirs="$noconfigdirs gprof"
476 ;;
477 mips*-*-*)
478 noconfigdirs="$noconfigdirs gprof"
479 ;;
480 romp-*-*)
481 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes"
482 ;;
483 sh-*-*)
484 case "${host}" in
485 i[345]86-*-vsta) ;; # don't add gprof back in
486 i[345]86-*-go32) ;; # don't add gprof back in
487 *) skipdirs=`echo " ${skipdirs} " | sed -e 's/ gprof / /'` ;;
488 esac
489 ;;
490 sparc-*-sunos4*)
491 if [ x${is_cross_compiler} != xno ] ; then
492 noconfigdirs="$noconfigdirs gdb gdbtest target-newlib"
493 else
494 use_gnu_ld=no
495 fi
496 ;;
497 v810-*-*)
498 noconfigdirs="$noconfigdirs bfd binutils gas gcc gdb ld target-libio target-libg++ target-libstdc++ opcodes"
499 ;;
500 vax-*-vms)
501 noconfigdirs="$noconfigdirs bfd binutils gdb ld target-newlib opcodes"
502 ;;
503 vax-*-*)
504 noconfigdirs="$noconfigdirs target-newlib"
505 ;;
506 *-*-lynxos*)
507 # Newlib makes problems for libg++ in crosses.
508 noconfigdirs="$noconfigdirs target-newlib"
509 ;;
510 *-*-macos* | \
511 *-*-mpw*)
512 # Macs want a resource compiler.
513 configdirs="$configdirs grez"
514 ;;
515esac
516
517# targets that need a second pass
518case "${target}" in
519 *-gm-magic*)
520 noconfigdirs="$noconfigdirs libgloss"
521 ;;
522esac
523
524# If we are building a Canadian Cross, discard tools that can not be built
525# using a cross compiler. FIXME: These tools should be fixed.
526if [ "${build}" != "${host}" ]; then
527 noconfigdirs="$noconfigdirs expect dejagnu make texinfo diff"
528fi
529
530# Make sure we don't let GNU ld be added if we didn't want it.
531if [ x$with_gnu_ld = xno ]; then
532 use_gnu_ld=no
533 noconfigdirs="$noconfigdirs ld"
534fi
535
536# Make sure we don't let GNU as be added if we didn't want it.
537if [ x$with_gnu_as = xno ]; then
538 use_gnu_as=no
539 noconfigdirs="$noconfigdirs gas"
540fi
541
542# Remove the entries in $skipdirs and $noconfigdirs from $configdirs and
543# $target_configdirs.
544# If we have the source for $noconfigdirs entries, add them to $notsupp.
545
546notsupp=""
547for dir in . $skipdirs $noconfigdirs ; do
548 dirname=`echo $dir | sed -e s/target-//g`
549 if [ $dir != . ] && echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
550 configdirs=`echo " ${configdirs} " | sed -e "s/ ${dir} / /"`
551 if [ -r $srcdir/$dirname/configure ] \
552 || [ -r $srcdir/$dirname/configure.in ]; then
553 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
554 true
555 else
556 notsupp="$notsupp $dir"
557 fi
558 fi
559 fi
560 if [ $dir != . ] && echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
561 target_configdirs=`echo " ${target_configdirs} " | sed -e "s/ ${dir} / /"`
562 if [ -r $srcdir/$dirname/configure ] \
563 || [ -r $srcdir/$dirname/configure.in ]; then
564 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
565 true
566 else
567 notsupp="$notsupp $dir"
568 fi
569 fi
570 fi
571done
572
573# Sometimes the tools are distributed with libiberty but with no other
574# libraries. In that case, we don't want to build target-libiberty.
575if [ -n "${target_configdirs}" ]; then
576 others=
577 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
578 if [ "$i" != "libiberty" ]; then
579 if [ -r $srcdir/$i/configure ] || [ -r $srcdir/$i/configure.in ]; then
580 others=yes;
581 break;
582 fi
583 fi
584 done
585 if [ -z "${others}" ]; then
586 target_configdirs=
587 fi
588fi
589
590# Deconfigure all subdirectories, in case we are changing the
591# configuration from one where a subdirectory is supported to one where it
592# is not.
593if [ -z "${norecursion}" -a -n "${configdirs}" ]; then
594 for i in `echo ${configdirs} | sed -e s/target-//g` ; do
595 rm -f $i/Makefile
596 done
597fi
598if [ -z "${norecursion}" -a -n "${target_configdirs}" ]; then
599 for i in `echo ${target_configdirs} | sed -e s/target-//` ; do
600 rm -f ${target_subdir}/$i/Makefile
601 done
602fi
603
604# Produce a warning message for the subdirs we can't configure.
605# This isn't especially interesting in the Cygnus tree, but in the individual
606# FSF releases, it's important to let people know when their machine isn't
607# supported by the one or two programs in a package.
608
609if [ -n "${notsupp}" ] && [ -z "${norecursion}" ]; then
610 # If $appdirs is non-empty, at least one of those directories must still
611 # be configured, or we error out. (E.g., if the gas release supports a
612 # specified target in some subdirs but not the gas subdir, we shouldn't
613 # pretend that all is well.)
614 if [ -n "$appdirs" ]; then
615 for dir in $appdirs ; do
616 if [ -r $dir/Makefile.in ]; then
617 if echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
618 appdirs=""
619 break
620 fi
621 if echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
622 appdirs=""
623 break
624 fi
625 fi
626 done
627 if [ -n "$appdirs" ]; then
628 echo "*** This configuration is not supported by this package." 1>&2
629 exit 1
630 fi
631 fi
632 # Okay, some application will build, or we don't care to check. Still
633 # notify of subdirs not getting built.
634 echo "*** This configuration is not supported in the following subdirectories:" 1>&2
635 echo " ${notsupp}" 1>&2
636 echo " (Any other directories should still work fine.)" 1>&2
637fi
638
639# Set with_gnu_as and with_gnu_ld as appropriate.
640#
641# This is done by determining whether or not the appropriate directory
642# is available, and by checking whether or not specific configurations
643# have requested that this magic not happen.
644#
645# The command line options always override the explicit settings in
646# configure.in, and the settings in configure.in override this magic.
647#
648# If the default for a toolchain is to use GNU as and ld, and you don't
649# want to do that, then you should use the --without-gnu-as and
650# --without-gnu-ld options for the configure script.
651
652if [ x${use_gnu_as} = x ] ; then
653 if [ x${with_gnu_as} != xno ] && echo " ${configdirs} " | grep " ${gasdir} " > /dev/null 2>&1 && [ -d ${srcdir}/${gasdir} ] ; then
654 with_gnu_as=yes
655 withoptions="$withoptions --with-gnu-as"
656 fi
657fi
658
659if [ x${use_gnu_ld} = x ] ; then
660 if [ x${with_gnu_ld} != xno ] && echo " ${configdirs} " | grep " ld " > /dev/null 2>&1 && [ -d ${srcdir}/ld ] ; then
661 with_gnu_ld=yes
662 withoptions="$withoptions --with-gnu-ld"
663 fi
664fi
665
666if [ x${enable_shared} = xyes ]; then
667 case "${target}" in
668 hppa*) target_makefile_frag=config/mt-papic ;;
669 i[345]86-*) target_makefile_frag=config/mt-x86pic ;;
670 *) target_makefile_frag=config/mt-${target_cpu}pic ;;
671 esac
672fi
673
674# post-target:
675
676# Make sure that the compiler is able to generate an executable. If it
677# can't, we are probably in trouble. We don't care whether we can run the
678# executable--we might be using a cross compiler--we only care whether it
679# can be created. At this point the main configure script has set CC.
680echo "int main () { return 0; }" > conftest.c
681${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c
682if [ $? = 0 ] && [ -s conftest ]; then
683 :
684else
685 echo 1>&2 "*** The command '${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c' failed."
686 echo 1>&2 "*** You must set the environment variable CC to a working compiler."
687 rm -f conftest*
688 exit 1
689fi
690rm -f conftest*
691
692# The Solaris /usr/ucb/cc compiler does not appear to work.
693case "${host}" in
694 sparc-sun-solaris2*)
695 if [ "`/usr/bin/which ${CC-cc}`" = "/usr/ucb/cc" ] ; then
696 could_use=
697 [ -d /opt/SUNWspro/bin ] && could_use="/opt/SUNWspro/bin"
698 if [ -d /opt/cygnus/bin ] ; then
699 if [ "$could_use" = "" ] ; then
700 could_use="/opt/cygnus/bin"
701 else
702 could_use="$could_use or /opt/cygnus/bin"
703 fi
704 fi
705 if [ "$could_use" = "" ] ; then
706 echo "Warning: compilation may fail because you're using"
707 echo "/usr/ucb/cc. You should change your PATH or CC "
708 echo "variable and rerun configure."
709 else
710 echo "Warning: compilation may fail because you're using"
711 echo "/usr/ucb/cc, when you should use the C compiler from"
712 echo "$could_use. You should change your"
713 echo "PATH or CC variable and rerun configure."
714 fi
715 fi
716 ;;
717esac
718
719# If --enable-shared was set, we must set LD_LIBRARY_PATH so that the
720# binutils tools will find libbfd.so.
721if [ "${enable_shared}" = "yes" ]; then
722 sed -e 's/^SET_LIB_PATH[ ]*=.*$/SET_LIB_PATH = $(REALLY_SET_LIB_PATH)/' \
723 Makefile > Makefile.tem
724 rm -f Makefile
725 mv -f Makefile.tem Makefile
726
727 case "${host}" in
728 *-*-hpux*)
729 sed -e 's/RPATH_ENVVAR[ ]*=.*$/RPATH_ENVVAR = SHLIB_PATH/' \
730 Makefile > Makefile.tem
731 rm -f Makefile
732 mv -f Makefile.tem Makefile
733 ;;
734 esac
735fi
736
737# Record target_configdirs and the configure arguments in Makefile.
738target_configdirs=`echo "${target_configdirs}" | sed -e 's/target-//g'`
739targargs=`echo "${arguments}" | \
740 sed -e 's/--norecursion//' \
741 -e 's/--cache[a-z-]*=[^ ]*//' \
742 -e 's/--ho[a-z-]*=[^ ]*//' \
743 -e 's/--ta[a-z-]*=[^ ]*//'`
744
745# Passing a --with-cross-host argument lets the target libraries know
746# whether they are being built with a cross-compiler or being built
747# native. However, it would be better to use other mechanisms to make the
748# sorts of decisions they want to make on this basis. Please consider
749# this option to be deprecated. FIXME.
750if [ x${is_cross_compiler} = xyes ]; then
751 targargs="--with-cross-host=${host_alias} ${targargs}"
752fi
753
754targargs="--host=${target_alias} ${targargs}"
755sed -e "s:^TARGET_CONFIGDIRS[ ]*=.*$:TARGET_CONFIGDIRS = ${target_configdirs}:" \
756 -e "s%^CONFIG_ARGUMENTS[ ]*=.*$%CONFIG_ARGUMENTS = ${targargs}%" \
757 -e "s%^TARGET_SUBDIR[ ]*=.*$%TARGET_SUBDIR = ${target_subdir}%" \
758 Makefile > Makefile.tem
759rm -f Makefile
760mv -f Makefile.tem Makefile
761
762#
763# Local Variables:
764# fill-column: 131
765# End:
766#
This page took 0.025296 seconds and 4 git commands to generate.